/**
 * Created with IntelliJ IDEA.
 * User: Patrick
 * Date: 3/12/13
 * Time: 1:48 PM
 */

public class Perturbation
{
    public int duration;
    public int ticksApplied = 0;  //a counter for how many times the perturbation has been applied
    public double severity;
    boolean hasStarted;
    boolean hasFinished;
    boolean isNaturePerturb;

    public Perturbation()
    {
        this.setHasStarted(false);
        this.setHasFinished(false);
    }

    public int getDuration()
    {
        return duration;
    }

    public void setDuration(int duration)
    {
        this.duration = duration;
    }

    public double getSeverity()
    {
        return severity;
    }

    public void setSeverity(double severity)
    {
        this.severity = severity;
    }

    public boolean isHasStarted()
    {
        return hasStarted;
    }

    public void setHasStarted(boolean hasStarted)
    {
        this.hasStarted = hasStarted;
    }

    public boolean isHasFinished()
    {
        return hasFinished;
    }

    public void setHasFinished(boolean hasFinished)
    {
        this.hasFinished = hasFinished;
    }

    public int getTicksApplied()
    {
        return ticksApplied;
    }

    public void setTicksApplied(int ticksApplied)
    {
        this.ticksApplied = ticksApplied;
    }

    public boolean isNaturePerturb()
    {
        return isNaturePerturb;
    }

    public void setIsNaturePerturb(boolean naturePerturb)
    {
        isNaturePerturb = naturePerturb;
    }

    public void updateDoneness()
    {
        if (this.getTicksApplied() > this.getDuration()) this.setHasFinished(true);
    }
}
