import java.util.ArrayList;

/**
 * Created with IntelliJ IDEA.
 * User: pjbitterman
 * Date: 3/1/13
 * Time: 12:36 PM
 */
public class PolicyMaker
{
    //class variables
    public static double switchGrassSubsidy = 0;
    public static double insurancePriceFactor = 0;
    public static ArrayList<Double> subsidyList = new ArrayList<Double>();
    public static ArrayList<Double> insuranceList = new ArrayList<Double>();

    public static int crpLeaseLength = 0;

    public static double getSwitchGrassSubsidy()
    {
        return switchGrassSubsidy;
    }

    public static void setSwitchGrassSubsidy(double switchGrassSubsidy)
    {
        PolicyMaker.switchGrassSubsidy = switchGrassSubsidy;
    }

    public static double getInsurancePriceFactor()
    {
        return insurancePriceFactor;
    }

    public static void setInsurancePriceFactor(double insurancePriceFactor)
    {
        PolicyMaker.insurancePriceFactor = insurancePriceFactor;
    }

    public static int getCrpLeaseLength()
    {
        return crpLeaseLength;
    }

    public static void setCrpLeaseLength(int crpLeaseLength)
    {
        PolicyMaker.crpLeaseLength = crpLeaseLength;
    }

    public static ArrayList<Double> getSubsidyList()
    {
        return subsidyList;
    }

    public static void setSubsidyList(ArrayList<Double> subsidyList)
    {
        PolicyMaker.subsidyList = subsidyList;
    }
    public static double getCurrYrSubsidyTotal()
    {
        if (subsidyList.size() > 1) return subsidyList.get(subsidyList.size()-1);
        else return 0;

    }

    public static void updateCurrYrSubsidyTotal(double value)
    {
        if (subsidyList.size() == 0)
        {
            subsidyList.add(value);
        }
        else
        {
            double currAmount = subsidyList.get(subsidyList.size()-1);
            subsidyList.set(subsidyList.size()-1, currAmount + value);
        }
    }

    public static ArrayList<Double> getInsuranceList()
    {
        return insuranceList;
    }

    public static void setInsuranceList(ArrayList<Double> insuranceList)
    {
        PolicyMaker.insuranceList = insuranceList;
    }

    public static double getCurrYrInsuranceTotal()
    {
        return insuranceList.get(insuranceList.size()-1);
    }

    public static void updateCurrYrInsuranceTotal(double value)
    {
        if (insuranceList.size() == 0)
        {
            insuranceList.add(value);
        }

        else
        {
            double currAmount = insuranceList.get(insuranceList.size()-1);
            insuranceList.set(insuranceList.size()-1, currAmount + value);
        }
    }

    public static void advanceListsToNextYear()
    {
        subsidyList.add(0.0);
        insuranceList.add(0.0);
    }


    public static void resetPolicyMaker()
    {
        switchGrassSubsidy = 0;
        insurancePriceFactor = 0;
        subsidyList = new ArrayList<Double>();
        insuranceList = new ArrayList<Double>();
    }
}
