import au.com.bytecode.opencsv.CSVWriter;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;


public class MyFileWriter
{
    public MyFileWriter()
    {
    }


    public void writeScenarioSummary(Scenario theScenario)
    {
        ArrayList<String[]>listToWrite = theScenario.getScenarioData();
        int identifier = theScenario.getScenarioID();
        this.writeCSV(listToWrite, identifier);

    }


    public void writeCSV(ArrayList<String[]> listToWrite, int identifier)
    {
        try
        {
            String outputPath = Controller.assembledOutPath;
            FileWriter fWriter = new FileWriter(outputPath + "/" + getDateTime() + "/" + "summary_" + "sc" + identifier + ".csv");
            CSVWriter myWriter = new CSVWriter(fWriter, ',');
            myWriter.writeAll(listToWrite);
            myWriter.close();
        }
        catch (IOException e)
        {
            System.out.println("Unable to create output file " + e.getMessage());
        }
    }

    private String getDateTime() {
        DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date();
        return dateFormat.format(date);
    }

}
